#ifndef CELLSTATE_H
#define CELLSTATE_H

#include <stdint.h>

typedef uint32_t CellState;

#define CS_Empty 0
#define CS_Wall 1
#define CS_LORock 0x02
#define CS_HORock 0x12
#define CS_Earth 3
#define CS_Lambda 4
#define CS_Lift 5
#define CS_Robot 6
#define CS_Trampoline(i) (((i)<<4)|7)
#define CS_Target(i) (((i)<<4)|8)
#define CS_Beard 9
#define CS_Razor 10

#define csIsEmpty(cs) ((cs) == CS_Empty)
#define csIsWall(cs) ((cs) == CS_Wall)
#define csIsRock(cs) (((cs) & 0xf) == 2)
#define csIsLORock(cs) ((cs) == CS_LORock)
#define csIsHORock(cs) ((cs) == CS_HORock)
#define csIsEarth(cs) ((cs) == CS_Earth)
#define csIsLambda(cs) ((cs) == CS_Lambda)
#define csIsLift(cs) ((cs) == CS_Lift)
#define csIsRobot(cs) ((cs) == CS_Robot)
#define csIsTrampoline(cs) (((cs) & 0xf) == 7)
#define csIsTarget(cs) (((cs) & 0xf) == 8)
#define csGetNumber(cs) (((cs) & 0xf0) >> 4)
#define csIsBeard(cs) ((cs) == CS_Beard)
#define csIsRazor(cs) ((cs) == CS_Razor)

#endif
