#include "CellState.h"
#include "Grid.h"
#include "Sim.h"
#include "Diff.h"
#include "Solve.h"
#include "Action.h"
#include "SignalHandler.h"
#include "Zone.h"
#include <stdio.h>
#include <stdlib.h>
#include <vector>

using std::vector;

int main(int argc, char* argv[])
{
    startSignalHandler();

    Grid grid;
    if (!readGrid(stdin, &grid)) {
        fprintf(stderr, "Error in input\n");
        return 1;
    }

    //writeGrid(stdout, grid);

    /*
    Diff diff;
    for (uint32_t i = 0; i < 100*1000000; i++) {
        step(&grid, Action_MoveUp, &diff);
    }

    writeGrid(stdout, grid, true);
    */

    vector<Action> trace;
    
    solve(grid, &trace, true);

    writeTrace(stdout, trace);
    fputc('\n', stdout);

    return 0;
}
